/*
 UDPSendReceiveString

 This sketch receives UDP message strings, prints them to the serial port
 and sends an "acknowledge" string back to the sender

 A Processing sketch is included at the end of file that can be used to send
 and receive messages for testing with a computer.

 created 21 Aug 2010
 by Michael Margolis

 This code is in the public domain.
 */


#include <Ethernet.h>
#include <EthernetUdp.h>

// Enter a MAC address and IP address for your controller below.
// The IP address will be dependent on your local network:
byte mac[] = {
  0xDE, 0xAD, 0xBE, 0xEF, 0xFE, 0xED
};
IPAddress ip(192, 168, 1, 177);

unsigned int localPort = 8888;      // local port to listen on

// buffers for receiving and sending data
char packetBuffer[UDP_TX_PACKET_MAX_SIZE];  // buffer to hold incoming packet,
char ReplyBuffer[] = "Rupjit Arduino responded";        // a string to send back

// An EthernetUDP instance to let us send and receive packets over UDP
EthernetUDP Udp;

void setup() {

  pinMode(8, OUTPUT);
 digitalWrite(8, LOW); 
 pinMode(9, OUTPUT);
 digitalWrite(10, LOW);
 pinMode(11, OUTPUT);
 digitalWrite(11, LOW);
 pinMode(12, OUTPUT);
 digitalWrite(12, LOW);
 pinMode(13, OUTPUT);
 digitalWrite(13, LOW);
 pinMode(10, OUTPUT);
 digitalWrite(10, LOW); 


  // You can use Ethernet.init(pin) to configure the CS pin
  Ethernet.init(10);  // Most Arduino shields
  //Ethernet.init(5);   // MKR ETH Shield
  //Ethernet.init(0);   // Teensy 2.0
  //Ethernet.init(20);  // Teensy++ 2.0
  //Ethernet.init(15);  // ESP8266 with Adafruit FeatherWing Ethernet
  //Ethernet.init(33);  // ESP32 with Adafruit FeatherWing Ethernet

  // start the Ethernet
  Ethernet.begin(mac, ip);

  // Open serial communications and wait for port to open:
  Serial.begin(9600);
  while (!Serial) {
    ; // wait for serial port to connect. Needed for native USB port only
  }

  // Check for Ethernet hardware present
  if (Ethernet.hardwareStatus() == EthernetNoHardware) {
    Serial.println("Ethernet shield was not found.  Sorry, can't run without hardware. :(");
    while (true) {
      delay(1); // do nothing, no point running without Ethernet hardware
    }
  }
  if (Ethernet.linkStatus() == LinkOFF) {
    Serial.println("Ethernet cable is not connected.");
  }

  // start UDP
  Udp.begin(localPort);
}

void loop() {
  // if there's data available, read a packet
  int packetSize = Udp.parsePacket();
  if (packetSize) {
    Serial.print("Received packet of size ");
    Serial.println(packetSize);
    Serial.print("From ");
    IPAddress remote = Udp.remoteIP();
    for (int i=0; i < 4; i++) {
      Serial.print(remote[i], DEC);
      if (i < 3) {
        Serial.print(".");
      }
    }
    Serial.print(", port ");
    Serial.println(Udp.remotePort());

    // read the packet into packetBuffer
    Udp.read(packetBuffer, UDP_TX_PACKET_MAX_SIZE);
    Serial.println("Contents:");
    Serial.println(packetBuffer);
    String teststr = String(packetBuffer);
    Serial.println(teststr);
    Serial.println(teststr);  
String mod_addr = teststr.substring(1,3);
Serial.println(mod_addr); 
String write_coil = teststr.substring(3,5); 
Serial.println(write_coil ); 
String addr_hi = teststr.substring(5,7); 
Serial.println(addr_hi); 
String addr_lo = teststr.substring(7,9); 
Serial.println(addr_lo); 
String data_hi = teststr.substring(9,11); 
Serial.println(data_hi); 

//------ CONTROL FOR CHANNEL 8 -----------------------
if(addr_lo == "08" && data_hi == "FF"){
  Serial.println("Trigger pin 8 ON"); 
  //Serial.println(:0605000800FFEE); write if required
  digitalWrite(8, HIGH); 
}
else { 
  if (addr_lo == "08" && data_hi == "00") {
    Serial.println("Trigger pin 8 OFF"); 
    digitalWrite(8, LOW); 
  }
}
//----------------------------------------------------

//------ CONTROL FOR CHANNEL 9 -----------------------
if(addr_lo == "09" && data_hi == "FF"){
  Serial.println("Trigger pin 9 ON"); 
  //Serial.println(:0605000800FFEE); write if required
  digitalWrite(9, HIGH); 
}
else { 
  if (addr_lo == "09" && data_hi == "00") {
    Serial.println("Trigger pin 9 OFF"); 
    digitalWrite(9, LOW); 
  }
}
//----------------------------------------------------

//------ CONTROL FOR CHANNEL10 -----------------------
if(addr_lo == "0A" && data_hi == "FF"){
  Serial.println("Trigger pin 10 ON"); 
  //Serial.println(:0605000800FFEE); write if required
  digitalWrite(10, HIGH); 
}
else { 
  if (addr_lo == "0A" && data_hi == "00") {
    Serial.println("Trigger pin 10 OFF"); 
    digitalWrite(10, LOW); 
  }
}
//----------------------------------------------------

//------ CONTROL FOR CHANNEL11 -----------------------
if(addr_lo == "0B" && data_hi == "FF"){
  Serial.println("Trigger pin 11 ON"); 
  //Serial.println(:0605000800FFEE); write if required
  digitalWrite(11, HIGH); 
}
else { 
  if (addr_lo == "0B" && data_hi == "00") {
    Serial.println("Trigger pin 11 OFF"); 
    digitalWrite(11, LOW); 
  }
}
//----------------------------------------------------

//------ CONTROL FOR CHANNEL12 -----------------------
if(addr_lo == "0C" && data_hi == "FF"){
  Serial.println("Trigger pin 12 ON"); 
  //Serial.println(:0605000800FFEE); write if required
  digitalWrite(12, HIGH); 
}
else { 
  if (addr_lo == "0C" && data_hi == "00") {
    Serial.println("Trigger pin 12 OFF"); 
    digitalWrite(12, LOW); 
  }
}
//----------------------------------------------------

//------ CONTROL FOR CHANNEL 13 -----------------------
if(addr_lo == "0D" && data_hi == "FF"){
  Serial.println("Trigger pin 13 ON"); 
  Serial.println();
  digitalWrite(13, HIGH); 
}
else { 
  if (addr_lo == "0D" && data_hi == "00") {
    Serial.println("Trigger pin 13 OFF"); 
    digitalWrite(13, LOW); 
  }
}
//----------------------------------------------------
delay(30);

    // send a reply to the IP address and port that sent us the packet we received
    Udp.beginPacket(Udp.remoteIP(), Udp.remotePort());
    Udp.write(ReplyBuffer);
    Udp.endPacket();
  }
  delay(10);
}


